libstdc++: std::tr2::__dynamic_bitset_base< _WordT, _Alloc > Struct Template Reference

libstdc++

std::tr2::__dynamic_bitset_base< _WordT, _Alloc > Struct Template Reference
Extensions » Dynamic Bitset.

`#include <dynamic_bitset>`

Inheritance diagram for std::tr2::__dynamic_bitset_base< _WordT, _Alloc >:
[legend]

## Public Types
typedef _Alloc | allocator_type
typedef _WordT | block_type
typedef size_t | size_type

## Public Member Functions
| __dynamic_bitset_base (__dynamic_bitset_base &&__b)=default
| __dynamic_bitset_base (const __dynamic_bitset_base &)=default
| __dynamic_bitset_base (const allocator_type &__alloc)
| __dynamic_bitset_base (size_type __nbits, unsigned long long __val=0ULL, const allocator_type &__alloc=allocator_type())
size_t | _M_are_all_aux () const noexcept
void | _M_clear () noexcept
void | _M_do_and (const __dynamic_bitset_base &__x) noexcept
void | _M_do_append_block (block_type __block, size_type __pos)
size_t | _M_do_count () const noexcept
void | _M_do_dif (const __dynamic_bitset_base &__x) noexcept
size_type | _M_do_find_first (size_t __not_found) const
size_type | _M_do_find_next (size_t __prev, size_t __not_found) const
void | _M_do_flip () noexcept
void | _M_do_left_shift (size_t __shift)
void | _M_do_or (const __dynamic_bitset_base &__x) noexcept
void | _M_do_reset () noexcept
void | _M_do_right_shift (size_t __shift)
void | _M_do_set () noexcept
unsigned long long | _M_do_to_ullong () const
unsigned long | _M_do_to_ulong () const
void | _M_do_xor (const __dynamic_bitset_base &__x) noexcept
allocator_type | _M_get_allocator () const noexcept
block_type | _M_getword (size_type __pos) const noexcept
block_type & | _M_getword (size_type __pos) noexcept
block_type | _M_hiword () const noexcept
block_type & | _M_hiword () noexcept
bool | _M_is_any () const noexcept
bool | _M_is_equal (const __dynamic_bitset_base &__x) const noexcept
bool | _M_is_less (const __dynamic_bitset_base &__x) const noexcept
bool | _M_is_proper_subset_of (const __dynamic_bitset_base &__b) const noexcept
bool | _M_is_subset_of (const __dynamic_bitset_base &__b) noexcept
void | _M_resize (size_t __nbits, bool __value)
size_type | _M_size () const noexcept
void | _M_swap (__dynamic_bitset_base &__b) noexcept
__dynamic_bitset_base & | operator= (__dynamic_bitset_base &&)=default
__dynamic_bitset_base & | operator= (const __dynamic_bitset_base &)=default

## Static Public Member Functions
static block_type | _S_maskbit (size_type __pos) noexcept
static size_type | _S_whichbit (size_type __pos) noexcept
static size_type | _S_whichbyte (size_type __pos) noexcept
static size_type | _S_whichword (size_type __pos) noexcept

## Public Attributes
std::vector< block_type, allocator_type > | _M_w

## Static Public Attributes
static const size_type | _S_bits_per_block
static const size_type | npos

## Detailed Description

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>
struct std::tr2::__dynamic_bitset_base< _WordT, _Alloc >

Base class, general case.

See documentation for dynamic_bitset.

Definition at line 64 of file dynamic_bitset.

## Member Typedef Documentation

## ◆ allocator_type

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

typedef _Alloc std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::allocator_type

Definition at line 70 of file dynamic_bitset.

## ◆ block_type

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

typedef _WordT std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::block_type

Definition at line 69 of file dynamic_bitset.

## ◆ size_type

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

typedef size_t std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::size_type

Definition at line 71 of file dynamic_bitset.

## Constructor & Destructor Documentation

## ◆ __dynamic_bitset_base() [1/2]

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::__dynamic_bitset_base | ( | const allocator_type & | __alloc | ) |
| inlineexplicit

Definition at line 80 of file dynamic_bitset.

## ◆ __dynamic_bitset_base() [2/2]

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::__dynamic_bitset_base | ( | size_type | __nbits,
|  | unsigned long long | __val = 0ULL,
|  | const allocator_type & | __alloc = allocator_type() )
| inlineexplicit

Definition at line 92 of file dynamic_bitset.

## Member Function Documentation

## ◆ _M_are_all_aux()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

size_t std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_are_all_aux | ( |  | ) | const
| inlinenoexcept

Definition at line 277 of file dynamic_bitset.

## ◆ _M_clear()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

void std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_clear | ( |  | ) |
| inlinenoexcept

Definition at line 124 of file dynamic_bitset.

## ◆ _M_do_and()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

void std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_and | ( | const __dynamic_bitset_base< _WordT, _Alloc > & | __x | ) |
| inlinenoexcept

Definition at line 179 of file dynamic_bitset.

## ◆ _M_do_append_block()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

void std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_append_block | ( | block_type | __block,
|  | size_type | __pos )
| inline

Definition at line 352 of file dynamic_bitset.

## ◆ _M_do_count()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

size_t std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_count | ( |  | ) | const
| inlinenoexcept

Definition at line 324 of file dynamic_bitset.

## ◆ _M_do_dif()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

void std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_dif | ( | const __dynamic_bitset_base< _WordT, _Alloc > & | __x | ) |
| inlinenoexcept

Definition at line 209 of file dynamic_bitset.

## ◆ _M_do_find_first()

template<typename _WordT, typename _Alloc>

size_t std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_find_first | ( | size_t | __not_found | ) | const

Definition at line 127 of file dynamic_bitset.tcc.

## ◆ _M_do_find_next()

template<typename _WordT, typename _Alloc>

size_t std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_find_next | ( | size_t | __prev,
|  | size_t | __not_found ) const

Definition at line 143 of file dynamic_bitset.tcc.

## ◆ _M_do_flip()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

void std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_flip | ( |  | ) |
| inlinenoexcept

Definition at line 225 of file dynamic_bitset.

## ◆ _M_do_left_shift()

template<typename _WordT, typename _Alloc>

void std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_left_shift | ( | size_t | __shift | ) |

Definition at line 46 of file dynamic_bitset.tcc.

## ◆ _M_do_or()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

void std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_or | ( | const __dynamic_bitset_base< _WordT, _Alloc > & | __x | ) |
| inlinenoexcept

Definition at line 189 of file dynamic_bitset.

## ◆ _M_do_reset()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

void std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_reset | ( |  | ) |
| inlinenoexcept

Definition at line 239 of file dynamic_bitset.

## ◆ _M_do_right_shift()

template<typename _WordT, typename _Alloc>

void std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_right_shift | ( | size_t | __shift | ) |

Definition at line 71 of file dynamic_bitset.tcc.

## ◆ _M_do_set()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

void std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_set | ( |  | ) |
| inlinenoexcept

Definition at line 232 of file dynamic_bitset.

## ◆ _M_do_to_ullong()

template<typename _WordT, typename _Alloc>

unsigned long long std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_to_ullong | ( |  | ) | const

Definition at line 112 of file dynamic_bitset.tcc.

## ◆ _M_do_to_ulong()

template<typename _WordT, typename _Alloc>

unsigned long std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_to_ulong | ( |  | ) | const

Definition at line 98 of file dynamic_bitset.tcc.

## ◆ _M_do_xor()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

void std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_do_xor | ( | const __dynamic_bitset_base< _WordT, _Alloc > & | __x | ) |
| inlinenoexcept

Definition at line 199 of file dynamic_bitset.

## ◆ _M_get_allocator()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

allocator_type std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_get_allocator | ( |  | ) | const
| inlinenoexcept

Definition at line 143 of file dynamic_bitset.

## ◆ _M_getword() [1/2]

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

block_type std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_getword | ( | size_type | __pos | ) | const
| inlinenoexcept

Definition at line 167 of file dynamic_bitset.

## ◆ _M_getword() [2/2]

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

block_type & std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_getword | ( | size_type | __pos | ) |
| inlinenoexcept

Definition at line 163 of file dynamic_bitset.

## ◆ _M_hiword() [1/2]

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

block_type std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_hiword | ( |  | ) | const
| inlinenoexcept

Definition at line 175 of file dynamic_bitset.

## ◆ _M_hiword() [2/2]

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

block_type & std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_hiword | ( |  | ) |
| inlinenoexcept

Definition at line 171 of file dynamic_bitset.

## ◆ _M_is_any()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

bool std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_is_any | ( |  | ) | const
| inlinenoexcept

Definition at line 287 of file dynamic_bitset.

## ◆ _M_is_equal()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

bool std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_is_equal | ( | const __dynamic_bitset_base< _WordT, _Alloc > & | __x | ) | const
| inlinenoexcept

Definition at line 245 of file dynamic_bitset.

## ◆ _M_is_less()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

bool std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_is_less | ( | const __dynamic_bitset_base< _WordT, _Alloc > & | __x | ) | const
| inlinenoexcept

Definition at line 259 of file dynamic_bitset.

## ◆ _M_is_proper_subset_of()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

bool std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_is_proper_subset_of | ( | const __dynamic_bitset_base< _WordT, _Alloc > & | __b | ) | const
| inlinenoexcept

Definition at line 310 of file dynamic_bitset.

## ◆ _M_is_subset_of()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

bool std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_is_subset_of | ( | const __dynamic_bitset_base< _WordT, _Alloc > & | __b | ) |
| inlinenoexcept

Definition at line 296 of file dynamic_bitset.

## ◆ _M_resize()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

void std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_resize | ( | size_t | __nbits,
|  | bool | __value )
| inline

Definition at line 128 of file dynamic_bitset.

## ◆ _M_size()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

size_type std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_size | ( |  | ) | const
| inlinenoexcept

Definition at line 333 of file dynamic_bitset.

## ◆ _M_swap()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

void std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_swap | ( | __dynamic_bitset_base< _WordT, _Alloc > & | __b | ) |
| inlinenoexcept

Definition at line 120 of file dynamic_bitset.

## ◆ _S_maskbit()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

block_type std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_S_maskbit | ( | size_type | __pos | ) |
| inlinestaticnoexcept

Definition at line 159 of file dynamic_bitset.

## ◆ _S_whichbit()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

size_type std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_S_whichbit | ( | size_type | __pos | ) |
| inlinestaticnoexcept

Definition at line 155 of file dynamic_bitset.

## ◆ _S_whichbyte()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

size_type std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_S_whichbyte | ( | size_type | __pos | ) |
| inlinestaticnoexcept

Definition at line 151 of file dynamic_bitset.

## ◆ _S_whichword()

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

size_type std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_S_whichword | ( | size_type | __pos | ) |
| inlinestaticnoexcept

Definition at line 147 of file dynamic_bitset.

## Member Data Documentation

## ◆ _M_w

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

std::vector<block_type, allocator_type> std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_M_w

0 is the least significant word.

Definition at line 77 of file dynamic_bitset.

## ◆ _S_bits_per_block

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

const size_type std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::_S_bits_per_block
| static

Definition at line 73 of file dynamic_bitset.

## ◆ npos

template<typename _WordT = unsigned long long, typename _Alloc = std::allocator<_WordT>>

const size_type std::tr2::__dynamic_bitset_base< _WordT, _Alloc >::npos
| static

Definition at line 74 of file dynamic_bitset.

The documentation for this struct was generated from the following files:

- dynamic_bitset
- dynamic_bitset.tcc